local wk = require("which-key")
wk.add({
  -- Git mappings
  { "<leader>g",   group = "git" },
  { "<leader>ga",  "<cmd>Git add<cr>",                                       desc = "Add" },
  { "<leader>gb",  "<cmd>Git blame<cr>",                                     desc = "Blame" },
  { "<leader>gc",  "<cmd>Git commit<cr>",                                    desc = "Commit" },
  { "<leader>gC",  desc = "git confict" },
  { "<leader>gCo", "<cmd>GitConflictChooseOurs<cr>",                         desc = "Choose ours" },
  { "<leader>gCt", "<cmd>GitConflictChooseTheirs<cr>",                       desc = "Choose theirs" },
  { "<leader>gCb", "<cmd>GitConflictChooseBoth<cr>",                         desc = "Choose both" },
  { "<leader>gCn", "<cmd>GitConflictChooseNone<cr>",                         desc = "Choose none" },
  { "<leader>gCN", "<cmd>GitConflictNextConflict<cr>",                       desc = "Next conflict" },
  { "<leader>gCp", "<cmd>GitConflictPrevConflict<cr>",                       desc = "Prev conflict" },
  { "<leader>gCl", "<cmd>GitConflictListQf<cr>",                             desc = "List quickfix" },
  { "<leader>gd",  "<cmd>Git diff<cr>",                                      desc = "Diff" },
  -- LSP mappings
  { "<leader>l",   group = "lsp" },
  { "<leader>lc",  "<cmd>lua vim.cmd.norm('gcc')<cr>",                       desc = "Toggle Comment",      mode = "n" },
  { "<leader>lc",  "<cmd>lua vim.cmd.norm('gc')<cr>",                        desc = "Toggle Comment",      mode = "v" },
  { "<leader>lC",  "<cmd>lua vim.lsp.buf.code_action()<cr>",                 desc = "Code Action" },
  { "<leader>lD",  "<cmd>lua vim.lsp.buf.declaration()<cr>",                 desc = "Declaration" },
  { "<leader>ld",  "<cmd>lua vim.lsp.buf.definition()<cr>",                  desc = "Definition" },
  { "<leader>lf",  "<cmd>lua vim.lsp.buf.format()<cr>",                      desc = "Format" },
  { "<leader>lh",  "<cmd>lua vim.lsp.buf.hover()<cr>",                       desc = "Hover" },
  { "<leader>li",  "<cmd>lua vim.lsp.buf.implementation()<cr>",              desc = "Implementation" },
  { "<leader>lR",  "<cmd>lua vim.lsp.buf.references()<cr>",                  desc = "References" },
  { "<leader>lr",  "<cmd>lua vim.lsp.buf.rename()<cr>",                      desc = "Rename" },
  { "<leader>ls",  "<cmd>lua vim.lsp.buf.signatur_help()<cr>",               desc = "Signature Help" },
  { "<leader>lt",  "<cmd>lua vim.lsp.buf.type_definition()<cr>",             desc = "Type Definition" },
  -- Mason mappings
  { "<leader>M",   group = "mason" },
  { "<leader>m",   "<cmd>Mason<cr>",                                         desc = "Mason" },
  { "<leader>Ml",  "<cmd>MasonLog<cr>",                                      desc = "Mason log" },
  { "<leader>Mu",  "<cmd>MasonUpdate<cr>",                                   desc = "Mason update" },
  -- oil mappings
  { "<leader>o",   group = "oil" },
  { "<leader>of",  "<cmd>Oil --float<cr>",                                   desc = "Open floating parent" },
  { "<leader>op",  "<cmd>lua require('oil.actions').preview.callback()<cr>", desc = "Show preview" },
  {
    "<leader>oc",
    "<cmd>lua require('oil.actions').close.callback()<cr>",
    desc = "Close",
    mode = "n",
  },
  { "<leader>oo", "<cmd>Oil<cr>",                           desc = "Open parent" },
  -- telescope mappings
  { "<leader>f",  group = "find" },
  { "<leader>ff", "<cmd>Telescope find_files<cr>",          desc = "Find files" },
  { "<leader>fg", "<cmd>Telescope live_grep<cr>",           desc = "Grep" },
  { "<leader>fb", "<cmd>Telescope buffers<cr>",             desc = "Buffers" },
  { "<leader>fh", "<cmd>Telescope help_tags<cr>",           desc = "Help tags" },
  -- terminal mappings
  { "<leader>t",  group = "term" },
  { "<leader>tt", "<cmd>ToggleTerm<cr>",                    mode = "n",                                      desc = "Toggle terminal" },
  { "<leader>ts", "<cmd>ToggleTermSendCurrentLine<cr>",     desc = "Send current line to terminal" },
  { "<leader>tl", "<cmd>ToggleTermSendVisualLines<cr>",     desc = "Send visualy selected lines to terminal" },
  { "<leader>tv", "<cmd>ToggleTermSendVisualSelection<cr>", desc = "Send visual selection to terminal" },
  { "<esc>",      "<cmd>ToggleTerm<cr>",                    mode = "t",                                      desc = "Toggle terminal" },
  { "<C-q>",      "<cmd>bd!<cr>",                           mode = "t",                                      desc = "Quit terminal" },
})
